<template>
  <b-modal
    ref="theModal"
    :title="modalTitle"
    size="extended"
    no-close-on-backdrop
    no-close-on-esc
    hide-header-close
  >
    <div class="row">
      <div class="col-6">
        <div v-if="!markdownEnabled">
          Markdown: <span class="text-danger">disabled</span>
        </div>
        <div v-else>
          Markdown: <span class="text-success">ENABLED</span> (<a
            href="https://www.markdownguide.org/basic-syntax/"
            target="_blank"
            >help / guide</a
          >)
        </div>

        <div v-if="pluralizationMode">
          <div class="font-weight-bold">Pluralization Mode enabled!</div>
          <div>eg.:</div>
          <div class="pl-4">
            <b-input readonly size="sm" value="car | cars"></b-input>
            <b-input
              readonly
              class="mt-2"
              size="sm"
              value="no apples | one apple | {count} apples"
            ></b-input>
          </div>
        </div>
      </div>
      <div class="col-6">
        <div v-if="brick">
          <div v-if="brick" class="mt-2">
            <div v-if="brick.definition.translationHint">
              <div>
                <strong>Developer Message:</strong>
              </div>
              <div class="pl-4">{{ brick.definition.translationHint }}</div>
            </div>
          </div>
          <div v-if="brick.definition.placeholders.length > 0">
            <div>
              <strong>Placeholders:</strong>
            </div>
            <div class="pl-4">
              <b-badge
                v-for="placeholder in brick.definition.placeholders"
                :key="placeholder"
                v-html="'{' + placeholder + '}'"
                variant="light"
                class="m-1"
              ></b-badge>
            </div>
          </div>
        </div>
      </div>
    </div>

    <hr />

    <div class="row">
      <div class="col-6">
        <div class="d-flex justify-content-between">
          <h3>Source ({{ translationSource }})</h3>
          <b-button
            @click="showPreview(referenceValue)"
            v-if="hasContent(referenceValue)"
            variant="info"
          >
            <font-awesome-icon :icon="['fas', 'eye']" />
          </b-button>
        </div>
        <div class="mt-2 p-2 bg-light">
          <b-form @submit.prevent="onSaveReference">
            <b-input
              v-if="!multilineEnabled"
              v-model="referenceValue"
              :readonly="!unlockReference"
            ></b-input>
            <b-form-textarea
              v-else
              :readonly="!unlockReference"
              v-model="referenceValue"
              rows="12"
            ></b-form-textarea>
          </b-form>

          <b-form-checkbox
            v-model="unlockReference"
            v-if="!unlockReference"
            switch
          >
            unlock
          </b-form-checkbox>

          <div v-if="unlockReference" class="mt-2">
            <b-button @click="onCancelReference" variant="danger"
              >CANCEL</b-button
            >
            <b-button @click="onSaveReference" variant="success" class="ml-2"
              >SAVE</b-button
            >
          </div>
        </div>
      </div>
      <div class="col-6">
        <div class="d-flex justify-content-between">
          <h3>Target ({{ translationTarget }})</h3>
          <b-button
            @click="showPreview(editValue)"
            v-if="hasContent(editValue)"
            variant="info"
          >
            <font-awesome-icon :icon="['fas', 'eye']" />
          </b-button>
        </div>
        <div class="mt-2">
          <b-form @submit.prevent="onSave">
            <b-input v-if="!multilineEnabled" v-model="editValue"></b-input>
            <b-textarea v-else v-model="editValue" rows="12"></b-textarea>
          </b-form>
        </div>
      </div>
    </div>

    <template v-slot:modal-footer>
      <b-button @click="onCancel" :disabled="unlockReference" variant="danger"
        >CANCEL</b-button
      >
      <b-button
        @click="onSave"
        :disabled="unlockReference"
        variant="success"
        class="ml-2"
        >SAVE</b-button
      >
    </template>

    <BrickPreviewModal ref="previewModal"></BrickPreviewModal>
  </b-modal>
</template>

<script>
import BrickPreviewModal from './BrickPreviewModal';
export default {
  components: {
    BrickPreviewModal,
  },
  data() {
    return {
      brick: null,
      translationSource: '',
      translationTarget: '',
      referenceValue: '',
      referenceValueOriginal: '',
      editValue: '',
      unlockReference: false,
    };
  },
  computed: {
    pluralizationMode() {
      if (this.brick) {
        return this.brick.definition.type === 'PLURAL';
      }

      return false;
    },
    markdownEnabled() {
      if (this.brick) {
        return this.brick.definition.type === 'MARKDOWN';
      }

      return false;
    },
    multilineEnabled() {
      if (this.brick) {
        return this.brick.definition.multiline === true;
      }

      return false;
    },
    modalTitle() {
      let title = 'Edit:';
      if (this.brick) {
        title = title + ' ' + this.brick.definition.key;
      }

      return title;
    },
  },
  methods: {
    hasContent(value) {
      if (!value || value === '') {
        return false;
      }

      return true;
    },
    showPreview(value) {
      this.$refs.previewModal.show(this.brick, 'override', value);
    },
    show(brick, translationSource, translationTarget) {
      this.brick = brick;
      this.translationSource = translationSource;
      this.translationTarget = translationTarget;

      let referenceValue = '';
      if (brick.sourceNext) {
        referenceValue = brick.sourceNext.value;
      } else if (brick.sourceDist) {
        referenceValue = brick.sourceDist.value;
      }

      let editValue = '';
      if (brick.targetNext) {
        editValue = brick.targetNext.value;
      } else if (brick.targetDist) {
        editValue = brick.targetDist.value;
      }

      this.referenceValue = referenceValue;
      this.referenceValueOriginal = referenceValue;
      this.editValue = editValue;

      this.$refs.theModal.show();
    },
    hide() {
      this.$refs.theModal.hide();
    },
    toggle() {
      this.$refs.theModal.toggle();
    },
    onCancel() {
      this.$bvModal
        .msgBoxConfirm('Are you sure?', { centered: false })
        .then((value) => {
          if (value === true) {
            this.hide();
          }
        })
        // eslint-disable-next-line handle-callback-err
        .catch((err) => {
          // An error occurred
        });
    },
    onCancelReference() {
      this.$bvModal
        .msgBoxConfirm('Are you sure?', { centered: false })
        .then((value) => {
          if (value === true) {
            this.referenceValue = this.referenceValueOriginal;
            this.unlockReference = false;
          }
        })
        // eslint-disable-next-line handle-callback-err
        .catch((err) => {
          // An error occurred
        });
    },
    onSave() {
      this.$emit('save', this.brick, this.translationTarget, this.editValue);
      this.hide();
    },
    onSaveReference() {
      this.$emit(
        'save',
        this.brick,
        this.translationSource,
        this.referenceValue
      );
      this.referenceValueOriginal = this.referenceValue;
      this.unlockReference = false;
    },
  },
};
</script>

<style>
.modal-extended {
  max-width: 1728px !important;
}
</style>
